# Flappy Engine
## About
Flappy Engine is a game engine for making Flappy Bird with editable features such as the bird color or the pipe size
## Installation
To set it up first install the engine using `pip install flappy_engine` once Flappy Engine is installed then its ready to be used!
## Usage
To use, first import the engine with `import flappy_engine` then, create the engine using `engine = flappy_engine.Engine()` once that is done then it's time to customize it!
## Customizing
Here is a list of all of the functions for customizing:

**flappy_engine.Engine().SetWindowSize(int: width, int: height)**

**flappy_engine.Engine().SetWindowTitle(str: title)**

**flappy_engine.Engine().SetJumpKey(flappy_engine.Key: key)**

**flappy_engine.Engine().SetWindowFPS(int: fps)**

**flappy_engine.Engine().SetWindowBackgroundColor(int: r, int: g, int: b)**

**flappy_engine.Engine().SetBirdGravity(int: gravity)**

**flappy_engine.Engine().SetBirdJumpForce(int: force)**

**flappy_engine.Engine().SetBirdJumpCooldown(float: cooldown)**

**flappy_engine.Engine().SetBirdColor(int: r, int: g, int: b)**

**flappy_engine.Engine().SetBirdSize(int: width, int: height)**

**flappy_engine.Engine().SetWindowSize(int: width, int: height)**

**flappy_engine.Engine().SetPipeSpeed(int: speed)**

**flappy_engine.Engine().SetPipeGap(int: gap)**

**flappy_engine.Engine().SetPipeFrequency(float: frequency)**

**flappy_engine.Engine().SetPipeColor(int: r, int: g, int: b)**

**flappy_engine.Engine().SetPipeWidth(int: width)**

**flappy_engine.Engine().SetScoreColor(int: r, int: g, int: b)**
## Running The Game
To run the game use `Engine.Run().run()`.
### Editing Stats In-Game
To edit stats in-game instead of using `Engine.Run().run()` use `process = Engine.Run()` then create a function and put the decorator `process.Frame`. To run the game, put `process.run()` after the funcion. Now the function will run every frame in the game!
## Example
Here is an exampple of how to use this engine:
```
import flappy_engine

r = 0
g = 0
b = 0

engine = flappy_engine.Engine()

engine.SetBirdColor(r, g, b)
engine.SetWindowBackgroundColor(r, g, b)

process = engine.Run()

@process.Frame
def frame():
    global r, g, b
    if r < 255:
        r += 1
    elif b < 255:
        b += 1
    elif g < 255:
        g += 1
    else:
        r = 0
        b = 0
        g = 0
    engine.SetPipeWidth(engine.score * 10 + 10)
    engine.SetScoreColor(r, g, b)
    engine.SetPipeColor(r, g, b)
    engine.SetBirdColor(r, g, b)

process.run()
```